<script lang="ts" setup>
import { computed } from 'vue';
import type { Component } from 'vue';
import { AutomatedCodeAlt, ShieldCheckLight, DigitalTransformation, ChevronLgRight } from 'slippers-ui/icons';
import type { BaseLink } from '@/types/base';

// Define Props
const props = defineProps<{
  title?: string;
  description?: string;
  items?: BaseLink[];
  disableLineBreaks?: boolean;
  dataNavLevelOne?: string;
  link?: BaseLink;
}>();

//Icons
const icons: Component = { AutomatedCodeAlt, ShieldCheckLight, DigitalTransformation };

// Computed Properties
const updatedTitle = computed(() => {
  return props.disableLineBreaks ? (props.title?.replace(/<\/?[^>]+(>|$)/g, '') ?? '') : props.title;
});
</script>

<template>
  <section class="nav-card" :class="{ 'nav-card--w-separator': props.items }">
    <article class="nav-card__article">
      <a
        class="nav-card__card"
        rel="bookmark"
        :href="props.link?.config.href"
        :data-ga-name="props.link?.config.dataGaName"
        :data-ga-location="props.link?.config.dataGaLocation"
        :data-nav-levelone="props.dataNavLevelOne"
        :data-nav-leveltwo="props.link?.config.dataGaName"
      >
        <div v-if="props.link?.config.icon && !props.link?.text" class="nav-card__icon">
          <SlpIcon :icon="icons[props.link?.config.icon]" size="md" />
        </div>
        <header>
          <SlpTypography variant="body1-bold" tag="div" class="title">
            <span v-html="updatedTitle" />
            <SlpIcon v-if="!props.link?.text" :icon="ChevronLgRight" size="md" class="slp-ml-8 icon" />
          </SlpTypography>
        </header>
        <section>
          <SlpTypography variant="body3" class="description">
            {{ props.description }}
          </SlpTypography>
        </section>

        <SlpTypography v-if="props.link?.text" variant="body3-bold" class="nav-card__link">
          {{ props.link.text }}
          <SlpIcon :icon="ChevronLgRight" size="md" class="slp-ml-4 icon" />
        </SlpTypography>
      </a>
      <ul v-if="props.items">
        <li v-for="item in props.items" :key="item.text" class="link cta">
          <a
            :href="item.config.href"
            :data-ga-name="item.config.dataGaName"
            :data-ga-location="item.config.dataGaLocation"
            :data-nav-levelone="props.dataNavLevelOne"
            :data-nav-leveltwo="item.config.dataGaName"
          >
            <SlpTypography variant="body2-bold" class="nav-card__link">
              {{ item.text }}
            </SlpTypography>
          </a>
        </li>
      </ul>
    </article>
  </section>
</template>

<style lang="scss" scoped>
.nav-card {
  display: flex;
  height: 100%;
  padding: 24px;
  align-items: flex-start;
  gap: 16px;
  flex-direction: column;
  background: white;
  flex: 1 1 300px;
  min-width: 300px;
  ul {
    width: 100%;
    & > :first-child {
      padding-top: 0 !important;
    }
  }

  .title {
    display: flex;
    flex-wrap: nowrap;
    align-items: center;
    color: black;
    &:hover {
      .title-chevron {
        visibility: visible;
      }
    }

    :deep(br) {
      display: none;
      content: '';
      @media (min-width: $breakpoint-lg) {
        display: block;
      }
    }
    :deep(.icon) {
      height: 16px;
      width: 16px;
      @media (min-width: $breakpoint-lg) {
        display: none;
      }
      * {
        fill: currentColor;
      }
    }
  }
  .title,
  .description,
  .items {
    white-space: normal;
  }
  &.nav-card--w-separator {
    border-left: 1px solid #e8e7eb;
    &:first-of-type {
      border-left-color: transparent;
    }
  }
  &__item {
    border-bottom: 1px solid #d1d0d3;
    margin: 0 16px;
    padding: 16px 0 !important;

    @media (min-width: $breakpoint-lg) {
      border-bottom: 0;
      margin: 0;
      padding: 0 0 16px 0 !important;
    }
    span {
      white-space: normal;
      font-weight: 400;
      @media (min-width: $breakpoint-lg) {
        font-weight: 600;
      }
    }
  }
  &__card {
    align-items: flex-start;
    background: #fff;
    display: flex;
    flex-direction: column;
    gap: 16px;
    width: 100%;
    &:hover {
      .link {
        color: $color-text-link-100;
      }
      .title {
        :deep(.icon) {
          color: $color-text-link-100;
          @media (min-width: $breakpoint-xl) {
            display: block;
            align-self: flex-end;
            margin-bottom: 6px;
          }
        }
      }
      .nav-card__link {
        text-decoration-color: #000;

        .slp-icon {
          transform: translateX(8px);
        }
      }
    }
    .icon {
      height: 16px;
      width: 16px;
      * {
        fill: currentColor;
      }
    }
  }
  &__icon {
    color: $color-primary-200;

    width: 24px;
    height: 24px;
    @media (min-width: $breakpoint-xl) {
      color: $color-surface-500;
    }
  }
  &__article {
    gap: 16px;
    display: flex;
    flex-direction: column;
  }
  .nav-card__link {
    color: #000;
    display: inline-flex;
    align-items: center;
    text-decoration: underline;
    text-decoration-color: transparent;
    text-underline-offset: 2px;
    transition: all 0.3s ease;
    .slp-icon {
      height: 12px !important;
      width: 12px !important;
      position: relative;
      transition: all 0.3s ease;
      transform: translateX(0);
      &:deep(svg) {
        left: 0;
        position: absolute;
        top: 0;
      }
    }
  }
}
.anchor-wrapper {
  &:hover {
    .cta,
    .link {
      color: $color-text-link-100;
    }
  }
}
.description {
  color: rgba(116, 113, 122, 0.75);
}
.items {
  display: flex;
  margin-top: 4px;
  align-items: flex-start;
  gap: 16px;
  flex-direction: column;
  @media (max-width: $breakpoint-lg) {
    padding-left: 16px;
    width: 100%;
    .item {
      border-bottom: 1px solid $color-surface-300;
      width: 100%;
      padding-bottom: 16px;
    }
    .link {
      color: $color-text-300;
      font-weight: 400;
    }
  }
}

.link {
  color: black;
  &:hover {
    color: $color-text-link-100;
  }
}

.cta {
  display: flex;
  align-items: center;
}

.title-chevron {
  align-self: flex-end;
  padding-bottom: 25px;
  visibility: hidden;
  @media (max-width: $breakpoint-lg) {
    visibility: visible;
  }
}
</style>
